// RippleHandHelper.js
// Version: 0.0.1
// Event: Lens Initialized
// Description: sets distance threshold for hand to cause the ripple effect

//@ui {"label":"Make sure to show either hand and the distance"}
//@ui {"label":"logged is smaller than Distance Threshold"}
//@input float threshold {"label":"Distance Threshold"}
//@input Component.ObjectTracking3D handTracking
//@input Asset.Material handMaterial
//@input SceneObject targetObj
//@input bool logMessage

var handJointName = "wrist";
var handJoint = script.handTracking.getAttachedObjects(handJointName)[0];
var dist;

//assigns a custom value to hand material to determine
//distance from camera in order to show ripple effect
//use DebugCamera and turn on logDistance to view details
script.handMaterial.mainPass.dist = script.threshold;

script.createEvent("UpdateEvent").bind(function(){

    if(!script.handTracking.isTracking()){
        //logMessage(script.handTracking.getSceneObject().name + " is Not Tracking.");
        return;
    }
    
    dist = script.targetObj.getTransform().getWorldPosition().distance(handJoint.getTransform().getWorldPosition());
    if(script.logMessage){
        if(dist > script.threshold){
            logMessage("Move " + script.handTracking.getSceneObject().name + " Closer to Camera!");
        }
        //Uncomment following line to log out hand distance to camera
        //logMessage(script.handTracking.getSceneObject().name + " Distance to Camera :" + dist);
    }
});

function logMessage(msg){
    if(script.logMessage){
        print(msg);
    }
}